unit Hebraeische_Methode_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Grids;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    BVerschluesseln: TButton;
    BLoeschen: TButton;
    BSchliessen: TButton;
    StringGrid1: TStringGrid;
    Label3: TLabel;
    Edit2: TEdit;
    procedure BSchliessenClick(Sender: TObject);
    procedure BLoeschenClick(Sender: TObject);
    procedure BVerschluesselnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

type
  text = array[1..100] of char;
  tabelle = array[1..20,1..20] of char;

var // Globale Variable
  Form1: TForm1;
  n, laenge: integer;
  klar, geheim: text;
  SG1: tabelle;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Tabsheet1.Show;
end;

{-------------------- Schliessen des Formulars ------------------------}

procedure TForm1.BSchliessenClick(Sender: TObject);
begin
  Close;
end;

{-------------------- Lschen der Eintraege --------------------------}

procedure TForm1.BLoeschenClick(Sender: TObject);
var
  s,z: integer;
begin
  Edit1.Clear;
  Edit2.Clear;
  with StringGrid1 do
    for z := 1 to n do
      for s := 1 to n do Cells[s-1,z-1] := '';
  Edit1.SetFocus;
  StringGrid1.Visible := false;
end;

{--------------------------- Loeschen der Eintraege -----------------------}

procedure loeschen;
var
  s,z: integer;
begin
  Form1.Edit1.Clear;
  Form1.Edit2.Clear;
  with Form1.StringGrid1 do
    for z := 1 to n do
      for s := 1 to n do Cells[s-1,z-1] := '';
  Form1.Edit1.SetFocus;
  Form1.StringGrid1.Visible := false;
end;

{---------------- Felder zu Beginn mit Leerzeichen fuellen ------------------}

procedure FelderFuellen(var t1,t2: Text);
var
  i : integer;
begin
  for i := 1 to 100 do begin
    t1[i] := ' ';
    t2[i] := ' ';
  end;
end;

{---------- Leerzeichen aus dem Feld entfernen ---------------------------}

function leere_Felder_Test(feld1: text; zeiger: integer): integer;
{Funktion zum Testen der Anzahl der hintereinander(!) liegenden leeren Elemente}
var
  zaehler: integer;
begin
  zaehler := 0;
  while feld1[zeiger] = ' ' do begin
    inc(zaehler);  {Zhler fr die Anzahl der nachzurckenden Elemente}
    inc(zeiger);
  end;
  result := zaehler;
end;

procedure LeerzeichenEntfernen (textlaenge: integer; var t: text);
var
  i, j, AnzLeereFelder: integer;
begin
  for i := 1 to textlaenge do
    if t[i] = ' ' then begin     // pruefen auf Leerzeichen
      AnzLeereFelder := leere_Felder_Test(t,i); {auf Anzahl der leeren Elemente testen}
      for j := i to textlaenge do t[j] := t[j+AnzLeereFelder]; // Nachruecken
    end;
  laenge := 0;
  repeat  // Laenge des Feldes ohne Leerzeichen ermitteln
    inc(laenge);
  until t[laenge] = ' ';
  laenge := laenge - 1;
end;

{--------------- Feld auf Laenge pruefen ------------}

procedure pruefen (var ok: boolean);
begin
  if laenge > 100 then begin  // pruefen auf Textlaenge
      Showmessage('Der Text ist zu lang!');
      loeschen;
      ok := false;
      exit;
    end;
  ok := true;
end;

{---------------- Matrix erzeugen ---------------------------------}

procedure MatrixErzeugen(anz: integer);
begin
  Form1.StringGrid1.ColCount := n;
  Form1.StringGrid1.RowCount := n;
  Form1.StringGrid1.Width := n*20;
  Form1.StringGrid1.Height := n*21;
  Form1.StringGrid1.Visible := True;
end;

{--------------- Klartext verschluesseln ----------------------------}

procedure verschluesseln(t: text; var t1: text);
var
  s,z, zaehler: integer;
begin
  zaehler := 1;
  for z := 1 to n do
    for s := 1 to n do begin
      SG1[z,s] := t[zaehler]; // Klartext aus Feld in Tabelle einlesen
      Form1.StringGrid1.Cells[s-1,z-1] := SG1[z,s]; // Ausgabe in StringGrid
      inc (zaehler);
    end;
  zaehler := 1;
  for s := 1 to n do
    for z := 1 to n do begin
      t1[zaehler] := SG1[z,s];  // Geheimtext aus Tabelle in Feld einlesen
      inc (zaehler);
    end;
end;

{-------------------- Geheimtext ausgeben --------------------------------}

procedure AusgabeGeheimtext(t:text);
var
  i: integer;
  ausgabe: string;
begin
  ausgabe := '';
  LeerzeichenEntfernen(laenge,t);
  for i := 1 to laenge do ausgabe := ausgabe + t[i];
  Form1.Edit2.Text := ausgabe;
end;

{------------------- Hauptprogramm Verschluesseln----------------------------}

procedure TForm1.BVerschluesselnClick(Sender: TObject);
var
  klartext: string;
  textlaenge, i: integer;
  pruefe: boolean;
begin
  pruefe := false;
  FelderFuellen(klar,geheim); // Felder mit Leerzeichen initialisieren
  klartext := Edit1.Text;  // Klartext einlesen
  textlaenge := length(klartext); // Laenge des Klartextes ermitteln
  for i := 1 to textlaenge do klar[i] := klartext[i]; // Klartext zeichenweise in Feld einlesen
  LeerzeichenEntfernen(textlaenge,klar);
  pruefen(pruefe);  // Klartext auf zulaessige Laenge pruefen
  n := trunc(Sqrt(laenge-1))+1; // Anz. der Spalten und Zeilen ermitteln
  if pruefe = true then begin  // wenn Test bestanden
    MatrixErzeugen(n);
    verschluesseln(klar,geheim); // Text verschlsseln und in StringGrid1 ausgeben
    AusgabeGeheimtext(geheim);  // Geheimtext ausgeben
  end;
end;
end.
